
/*
 *  header - $Id: machine.h,v 1.2 1997/06/10 18:49:27 qian Exp $
 *
 *  machine dependent functions
 */


/*********************************************************************
types & constants
*********************************************************************/


/*********************************************************************
variables
*********************************************************************/


/*********************************************************************
functions
*********************************************************************/

/* allocate memory space */
extern char *mgAllocate(int nunit, int szunit);

/* get protection (including MM and TLB) during initialization */
extern void mgGetInitProt(int pageno, unsigned char *p_prot);

/* get protection (including MM and TLB) */
extern void mgGetProt(int pageno, unsigned char *p_prot);

/* set protection (including MM and TLB) */
extern void mgSetProt(int pageno, unsigned char prot);

/* set machine-dependent read-only protection (including MM and TLB) */
extern void mgSetReadOnly(int pageno, unsigned char *p_prot);

/* set machine-dependent read-write protection (including MM and TLB) */
extern void mgSetReadWrite(int pageno, unsigned char *p_prot);

/* read in a page */
extern int mgRead(char *content,
		  int pageno, u_short offset, u_short size);

/* write in a page */
extern int mgWrite(char *content,
		  int pageno, u_short offset, u_short size);

/* report programmer's error */
extern void mgReportImpossible(char *msg);

/* report memguard fault */
extern void mgReportFault(caddr_t vaddr, u_short length);

/* report invariant violation */
extern void mgReportViolate(mginvariant_t *pinvariant,
                        caddr_t vaddr, u_short offset, u_short length);

/* report invariant confliction */
extern void mgReportConflict(mginvariant_t *pinvariant,
		        char *name, caddr_t vaddr, u_int size);

/* report invariant error size */
extern void mgReportSize(mginvariant_t *pinvariant,
			caddr_t vaddr, u_int size);

/* report invariant not found */
extern void mgReportNotfound(mginvariant_t *pinvariant,
			caddr_t vaddr, u_int size);

