
/*
 *  header - $Id: memguard_private.h,v 1.2 1997/06/10 18:49:27 qian Exp $
 *
 *  private functions for "memguard.c",
 *          a library for memory-based guard tool
 */


/*********************************************************************
types & constants
*********************************************************************/


/*********************************************************************
variables
*********************************************************************/


/*********************************************************************
functions
*********************************************************************/

/* enable and disable the tool */
extern void mg_enable(void);
extern void mg_disable(void);

/* check conflict */
extern mginvariant_t *mg_checkconflict(mgpage_t *pgp,
			    char *name, caddr_t vaddr, u_int size);
/*  #define CHECK_CONFLICT	pointer to the conflicting invariant */
/*  #define CHECK_NOCONFLICT	NULL */

/* search the invariant */
extern int mg_search(mgpage_t *pgp, caddr_t vaddr, u_int size);
#    define SEARCH_SUCCESS	0	/* found */
#    define SEARCH_VADDR	-1	/* error virtual address:
					   non-exists */
#    define SEARCH_SIZE		-2	/* error size */

/* add the invariant */
extern void mg_add(mgpage_t *pgp,
		   char *name, caddr_t vaddr, u_int size);

/* delete the invariant */
extern int mg_delete(mgpage_t *pgp, caddr_t vaddr);
#    define DELETE_SUCCESS	0	/* found */
#    define DELETE_VADDR	-1	/* error virtual address:
					   non-exists */

/* set/get/assert the invariant */
extern int  mg_sga(int flag, mgpage_t *pgp,
		   caddr_t vaddr, u_int size, char *content);
    /* flag */
#    define SGA_SET	0	/* set the invariant */
#    define SGA_GET	1	/* get the invariant */
#    define SGA_ASSERT	2	/* assert the invariant */

#    define SGA_OK	0	/* success */
#    define SGA_ERROR	-1	/* error */

